#pragma once

namespace Ents {class Player;}
namespace Input {class InputMngr;}
namespace LayerPlaying {class WorldSyncMngr;}
namespace Ld {class ColumnMask;}
namespace Particles {class BillboardMngr;}
namespace SceneGfx {class World;}
namespace SceneSim {class World;}
namespace Tiny {class TinyWorlds;}

namespace ClientEnts
{
	struct UpdateData
	{
		UpdateData ();
		~UpdateData ();

		RakNet::Time timeNow;
		float timeStep;

		Ents::Player * player;
		Input::InputMngr * inputMngr;
		LayerPlaying::WorldSyncMngr * worldSyncMngr;
		SceneGfx::World * renderer;
		SceneSim::World * sim;

		Tiny::TinyWorlds * tinyWorlds;
		Ld::ColumnMask * columnMask;

		Particles::BillboardMngr * billboards;
	};
}
