#pragma once

namespace Effects {class SkydomeParams;}
namespace Gfx {namespace Buffers {class TriList;}}
namespace Gfx {class GfxTex;}

namespace Effects
{
	class Skydome
	{
	public: 
		
		Skydome (const SkydomeParams * params);
		~Skydome ();

		void Render (Vec3 cameraPos);

	private:

		void SetVertex (Gfx::VertexTypes::XyzUvRgb * verts, int segIdx, int segCount, int ringIdx, int ringCount);
		Vec4 CalcColour (Vec3 dir);
		Vec4 ApplyRange (Vec4 rgba, float weight, float min, float max, Int4 minRgba, Int4 maxRgba);

		Gfx::Buffers::TriList * buffer;

		Gfx::GfxTex * tex;
	};
}
