#pragma once

namespace CellMesh {class Mngr;}
namespace ClientEnts {struct UpdateData;}
namespace Ents {class Player;}
namespace Gfx {class Camera;}
namespace Gfx {class GfxTex;}

namespace Ents
{
	class PlayerOsd
	{
	public:

		PlayerOsd (Player * player, CellMesh::Mngr * meshes);
		~PlayerOsd ();

		void Update (ClientEnts::UpdateData * update, bool allowUserInput);
		void Render (Gfx::Camera * camera);

		Player * player;

		CellMesh::Mngr * meshes;
		Gfx::GfxTex * crosshair;
		Gfx::GfxTex * editTex;
	};
}