#pragma once

#include "Controls_Button.h"

namespace Menus
{
	namespace Controls
	{
		class ButtonCycle : public Button
		{
		public:

			ButtonCycle (Int2 tl, Text * options, int optionsCount, OnExecuted onExecuted, int * currentIdx);
			virtual ~ButtonCycle ();

			virtual void Render (Int2 offset, int passIdx, Gfx::Font * font);

			virtual bool Executed ();

		private:

			Text * options;
			int optionsCount;
			
			int * currentIdx;
		};
	}
}
