#include "stdafx.h"

#include "Controls_ButtonToPage.h"
#include "Menus_Pages.h"

namespace Menus
{
	namespace Controls
	{
		ButtonToPage::ButtonToPage (Int2 tl, TextRef label, TextRef toId, Pages * pages) 
			: Button (tl, label),
			toId (toId),
			pages (pages)
		{
			assert (pages != NULL);
		}

		ButtonToPage::ButtonToPage (Int2 tl, TextRef label, TextRef toId, Pages * pages, OnExecuted onExecuted, void * data) 
			: Button (tl, label, onExecuted, data),
			toId (toId),
			pages (pages)
		{
			assert (pages != NULL);
		}

		bool ButtonToPage::Executed ()
		{
			bool isOk = Button::Executed ();
			if (isOk)
			{
				pages->OpenPage (toId, true);
			}
			return isOk;
		}
	}
}
