#pragma once

#include "Controls_Base.h"

namespace Menus
{
	namespace Controls
	{
		class Checkbox : public Base
		{
		public:

			Checkbox (Int2 tl, const char * label, bool * variable);
			virtual ~Checkbox ();

			virtual bool IsHighlighted (Int2 cursor) const;
			virtual bool IsHighlightable () const {return true;}

			virtual void Update (Input::InputMngr * inputMngr);
			virtual void Render (Int2 offset, int passIdx, Gfx::Font * font);

			const char * label;
			bool * variable;
		};
	}
}
