#pragma once

#include <map>

namespace Menus {class Page;}

namespace Menus
{
	class Pages
	{
	public:

		Pages ();
		~Pages ();

		void Update ();
		void Render ();

		void OpenPage (TextRef id, bool resetPage);

		Page * AddPage (Page * page);
		Page * GetPage (TextRef id);

	private:

		typedef std::map <Text, Page *> PageCollection;
		typedef PageCollection::iterator PageCollectionIt;
		PageCollection collection;

		Page * currentOpen;
	};
}
