#include "stdafx.h"

#include "Shapes_InitData.h"
#include "CellMesh_ShapeBase.h"

namespace CellMesh
{
	namespace Shapes
	{
		void InitCross (ShapeBase * shape, int tex)
		{
			float unit = 1.0f / 16.0f;

			InitData data (1, 4 * 2, SceneSim::FF_OTHER, 0);

			shape->Init (&data, tex);

			//shape->entCollisions = SceneSim::EC_NONE;
			shape->gfxBlocking = CellMesh::GB_NONE;

			shape->Init_AddQuad (&data, 0, SceneSim::F_OTHER, Vec3 (0.0f, 1.0f, 0.0f), Vec3 (1.0f, 0.0f, 1.0f), Vec3 (0.0f, -1.0f, 0.0f), SceneSim::F_OTHER, tex);
			shape->Init_AddQuad (&data, 0, SceneSim::F_OTHER, Vec3 (1.0f, 1.0f, 1.0f), Vec3 (-1.0f, 0.0f, -1.0f), Vec3 (0.0f, -1.0f, 0.0f), SceneSim::F_OTHER, tex);
			shape->Init_AddQuad (&data, 0, SceneSim::F_OTHER, Vec3 (1.0f, 1.0f, 0.0f), Vec3 (-1.0f, 0.0f, 1.0f), Vec3 (0.0f, -1.0f, 0.0f), SceneSim::F_OTHER, tex);
			shape->Init_AddQuad (&data, 0, SceneSim::F_OTHER, Vec3 (0.0f, 1.0f, 1.0f), Vec3 (1.0f, 0.0f, -1.0f), Vec3 (0.0f, -1.0f, 0.0f), SceneSim::F_OTHER, tex);

			shape->Init_ApplyUvRgbs (&data, 0, Vec4 (1.0f, 1.0f, 1.0f, 1.0f));
			shape->Init_Finish (&data, 0);
		}
	}
}
