#pragma once

namespace Gfx {class Viewport;}

namespace Gfx
{
	class Camera
	{
	public:

		Camera (const Viewport * viewport);

		void Apply ();

		void CalcProjectionMatrix (int w, int h);
		void CalcViewMatrix (int w, int h);
		
		Vec3 xyz;
		Vec3 ypr;

		float clipNear;
		float clipFar;

		Mat44 matProjection;
		Mat44 matView;
	};
}
