#pragma once

namespace Gfx {class Font;}

namespace Gfx
{
	struct FontSentance
	{
		FontSentance ();

		void Set (Gfx::Font * font, const char * text, int maxPixels);
		void Draw (Gfx::Font * font, const char * text, Int2 pos);

		bool hasFitted;
		int linesUsed;

		static const int linesMax = 10;
		int charStart [linesMax];
		int charEnd [linesMax];
		int pixelLength [linesMax];
		int pixelLongest;
	};
}