#pragma once

namespace Particles
{
	class Billboard
	{
	public:

		Billboard ();

		void Update (float timeDelta);
		void Render (Int3 fromColumnId, Vec3 right, Vec3 up, Vec3 in);

		void Set (Int3 columnId, Vec3 columnPos, Vec3 velocity, float size, float rotation, float rotationDelta, float age, float lifespan, Int4 rgba);

		bool inUse;

		int texId;
		Int3 columnId;
		Vec3 columnPos;
		Vec3 velocity;
		float size;
		float rotation;
		float rotationDelta;
		float age;
		float lifespan;
		Int4 rgba;
	};
}
