#include "stdafx.h"
//
//#include <vector>
//
//#include "CsgEffect/CsgEffect_ColumnChanges.h"
//#include "CsgEffect/CsgEffect_Sphere.h"
//#include "SceneCollections/SceneCollections_LocalColumns.h"
//#include "SceneSim/SceneSim_Column.h"
//#include "SceneSim/SceneSim_ColumnCells.h"
//#include "SceneSim/SceneSim_Room.h"
//#include "SceneSim/SceneSim_World.h"
//
//#include "Cmds_ApplyCsg.h"
//#include "CmdsGfx_ApplyCsg.h"
//#include "SceneChange_ColumnData.h"
//#include "SceneChange_SceneChangeMngr.h"
//
//namespace SceneChange
//{
//	namespace Cmds
//	{
//		ApplyCsg::ApplyCsg (Thread::JobMngr * jobMngr)
//			: Job (jobMngr, true),
//			columnsDirty (NULL),
//			columnsEdge (NULL)
//		{
//		}
//
//		ApplyCsg::~ApplyCsg ()
//		{
//			delete columnsDirty;
//
//			if (columnsEdge != NULL)
//			{
//				columnsEdge->DeleteAll ();
//				delete columnsEdge;
//			}
//		}
//
//		Thread::JOBSTATES ApplyCsg::JobDoWork ()
//		{
//			columnsDirty = aah_new SceneCollections::LocalColumns (columnId, 3);
//			std::vector <Int3> dirtyEdges;
//
//			CsgEffect::ColumnChanges changes (cellType);
//			CsgEffect::Sphere * csgEffect = aah_new CsgEffect::Sphere (columnId, cellId, radius);
//			const int columnsCount = csgEffect->GetColumnAffectedCount ();
//
//			SceneSim::Room * simRoom = sceneChangeMngr->GetSimWorld ()->GetRoom (roomId);
//			assert (simRoom != NULL);
//
//			const CellBuilder::Mngr * cellBuilder = simRoom->GetCellBuilder ();
//
//			for (int columnIdx = 0; columnIdx < columnsCount; ++columnIdx)
//			{
//				const Int3 affectedColumnId = csgEffect->GetColumnIdAffected (columnIdx);
//
//				ColumnData columnData;
//				const bool isValid = sceneChangeMngr->GetColumnData (affectedColumnId, &columnData);
//
//				if (isValid && columnData.sim != NULL && (columnData.sim->flags & SceneSim::Column::SF_NO_CELLS) == 0)
//				{
//					changes.Clear ();
//					csgEffect->ApplyChanges (columnIdx, columnData.sim, cellBuilder, &changes);
//					columnData.sim->SetLastModifiedTime (applied);
//
//					SceneSim::Column * copy = aah_new SceneSim::Column (*columnData.sim);
//					assert (copy->GetRoom () == NULL);
//					columnsDirty->AddColumn (copy);
//
//					changes.CalcEdgesTouched ();
//					if (changes.edgesTouched [SceneSim::F_N]) {dirtyEdges.push_back (affectedColumnId + Int3 (0, 0, 1));}
//					if (changes.edgesTouched [SceneSim::F_E]) {dirtyEdges.push_back (affectedColumnId + Int3 (1, 0, 0));}
//					if (changes.edgesTouched [SceneSim::F_S]) {dirtyEdges.push_back (affectedColumnId + Int3 (0, 0, -1));}
//					if (changes.edgesTouched [SceneSim::F_W]) {dirtyEdges.push_back (affectedColumnId + Int3 (-1, 0, 0));}
//				}
//			}
//
//			delete csgEffect;
//
//			// check if any dirtyEdges need adding if they arent already in the columnsDirty collection
//			for (int checkIdx = 0; checkIdx < dirtyEdges.size (); ++checkIdx)
//			{
//				if (columnsDirty->GetColumn (dirtyEdges [checkIdx]) == NULL)
//				{
//					ColumnData columnData;
//					bool isValid = sceneChangeMngr->GetColumnData (dirtyEdges [checkIdx], &columnData);
//
//					if (isValid && columnData.sim != NULL)
//					{
//						SceneSim::Column * copy = aah_new SceneSim::Column (*columnData.sim);
//						columnsDirty->AddColumn (copy);
//					}
//				}
//			}
//
//			// get all the edge columns
//			columnsEdge = aah_new SceneCollections::LocalColumns (columnId, 4);
//			for (int idx = 0; idx < columnsDirty->GetMaxColumnsCount (); ++idx)
//			{
//				SceneSim::Column * column = columnsDirty->GetNthColumn (idx);
//				if (column != NULL)
//				{
//					AddEdgeIfEmpty (column->columnId + Int3 (0, 0, 1));
//					AddEdgeIfEmpty (column->columnId + Int3 (1, 0, 0));
//					AddEdgeIfEmpty (column->columnId + Int3 (0, 0, -1));
//					AddEdgeIfEmpty (column->columnId + Int3 (-1, 0, 0));
//				}
//			}
//
//			return Thread::JS_WORKDONE;
//		}
//
//		Thread::JOBSTATES ApplyCsg::JobOnCompleted ()
//		{
//			SceneSim::Room * simRoom = sceneChangeMngr->GetSimWorld ()->GetRoom (roomId);
//			assert (simRoom != NULL);
//
//			aah_new CmdsGfx::ApplyCsg (sceneChangeMngr, &applied, roomId, columnsDirty, columnsEdge);
//			
//			delete columnsDirty;
//			columnsDirty = NULL;
//
//			delete columnsEdge;
//			columnsEdge = NULL;
//
//			return Thread::JS_COMPLETED;
//		}
//
//		void ApplyCsg::AddEdgeIfEmpty (Int3 columnId)
//		{
//			if (columnsDirty->GetColumn (columnId) == NULL && columnsEdge->GetColumn (columnId) == NULL)
//			{
//				ColumnData columnData;
//				bool isValid = sceneChangeMngr->GetColumnData (columnId, &columnData);
//				if (isValid && columnData.sim != NULL)
//				{
//					columnsEdge->AddColumn (aah_new SceneSim::Column (*columnData.sim));
//				}
//			}
//		}
//	}
//}
//
//
