#pragma once

#include "Thread/Thread_Job.h"

namespace Comms {class BitStream;}
namespace SceneCollections {class LocalColumns;}

namespace SceneChange
{
	namespace Cmds
	{
		class ApplyCsg : public Thread::Job
		{
		public:

			ApplyCsg (Thread::JobMngr * jobMngr);
			virtual ~ApplyCsg ();

			RakNet::Time applied;
			Text roomId;
			Int3 columnId;
			Int3 cellId;
			float radius;
			int cellType;

		protected:

			virtual Thread::JOBSTATES JobDoWork ();
			virtual Thread::JOBSTATES JobOnCompleted ();

		private:

			void AddEdgeIfEmpty (Int3 columnId);

			SceneCollections::LocalColumns * columnsDirty;
			SceneCollections::LocalColumns * columnsEdge;
		};
	}
}
