#include "stdafx.h"
//
//#include <algorithm>
//
//#include "SceneSim/SceneSim_Column.h"
//#include "SceneSim/SceneSim_Room.h"
//#include "SceneSim/SceneSim_World.h"
//#include "Thread/Thread_JobMngr.h"
//
//#include "CmdsGfx_ColumnGfxCreate.h"
//#include "SceneChange_CmdBase.h"
//#include "SceneChange_ColumnData.h"
//#include "SceneChange_SceneChangeMngr.h"
//
//namespace SceneChange
//{
//	struct CompareFunction
//	{
//		CompareFunction (Int3 columnId) : columnId (columnId) {}
//
//		bool operator () (Int3 colA, Int3 colB) 
//		{
//			return (LengthSqr (colA - columnId) < LengthSqr (colB - columnId));
//		}
//		
//		const Int3 columnId;
//	};
//
//	void ClearCallback (void * cellPtr)
//	{
//		ColumnData * data = (ColumnData *) cellPtr;
//		delete data->sim;
//		data->sim = NULL;
//	}
//
//	SceneChangeMngr::SceneChangeMngr (SceneGfx::World * gfxWorld, SceneSim::World * simWorld)
//		: gfxWorld (gfxWorld),
//		simWorld (simWorld)
//	{
//		assert (gfxWorld != NULL);
//		assert (simWorld != NULL);
//
//		jobMngrIncomingEvents = aah_new Thread::JobMngr ("SceneChangeMngr incoming events", false);
//		jobMngrGfxBuilder = aah_new Thread::JobMngr ("SceneChangeMngr gfx builder", false);
//
//		lock = SDL_CreateMutex ();
//	}
//
//	SceneChangeMngr::~SceneChangeMngr ()
//	{
//		jobMngrIncomingEvents->FinishCurrentJobAndDeleteAll ();
//		delete jobMngrIncomingEvents;
//
//		jobMngrGfxBuilder->FinishCurrentJobAndDeleteAll ();
//		delete jobMngrGfxBuilder;
//
//		std::deque <CmdBase *>::iterator it = incomingEventsQueue.begin ();
//		for (; it != incomingEventsQueue.end (); ++it)
//		{
//			delete *it;
//		}
//		incomingEventsQueue.clear ();
//
//		SDL_DestroyMutex (lock);
//		lock = NULL;
//
//		//while (cmds.size () > 0)
//		//{
//		//	CmdBase * cmd = cmds.front ();
//		//	cmds.pop_front ();
//
//		//	delete cmd;
//		//}
//
//		//delete columnDataColl;
//
//		columnDataColl.Clear (ClearCallback);
//	}
//
//	SceneGfx::World * SceneChangeMngr::GetGfxWorld () const
//	{
//		return gfxWorld;
//	}
//
//	SceneSim::World * SceneChangeMngr::GetSimWorld () const
//	{
//		return simWorld;
//	}
//
//	Thread::JobMngr * SceneChangeMngr::GetJobMngrIncomingEvents () const
//	{
//		return jobMngrIncomingEvents;
//	}
//
//	Thread::JobMngr * SceneChangeMngr::GetJobMngrGfxBuilder () const
//	{
//		return jobMngrGfxBuilder;
//	}
//	
//	void SceneChangeMngr::CreateColumnData (Int3 columnId, ColumnData * columnData)
//	{
//		SDL_LockMutex (lock);
//
//		assert (!columnDataColl.Get (columnId, &ColumnData ()));
//
//		columnDataColl.AddRef (columnId);
//		if (columnData == NULL)
//		{
//			columnDataColl.Set (columnId, &ColumnData ());
//		}
//		else
//		{
//			columnDataColl.Set (columnId, columnData);
//		}
//		
//		SDL_UnlockMutex (lock);
//	}
//
//	bool SceneChangeMngr::GetColumnData (Int3 columnId, ColumnData * columnData) const
//	{
//		assert (columnData != NULL);
//
//		SDL_LockMutex (lock);
//		bool isValid = columnDataColl.Get (columnId, columnData);
//		SDL_UnlockMutex (lock);
//		return isValid;
//	}
//
//	bool SceneChangeMngr::GetColumnData (Int3 columnId, ColumnData * columnData)
//	{
//		assert (columnData != NULL);
//
//		SDL_LockMutex (lock);
//		bool isValid = columnDataColl.Get (columnId, columnData);
//		SDL_UnlockMutex (lock);
//		return isValid;
//	}
//
//	void SceneChangeMngr::SetColumnData (Int3 columnId, const ColumnData * columnData)
//	{
//		assert (columnData != NULL);
//
//		SDL_LockMutex (lock);
//		columnDataColl.Set (columnId, columnData);
//		SDL_UnlockMutex (lock);
//	}
//
//	void SceneChangeMngr::DeleteColumnData (Int3 columnId)
//	{
//		SDL_LockMutex (lock);
//		columnDataColl.SubRef (columnId);
//		SDL_UnlockMutex (lock);
//	}
//
//	void SceneChangeMngr::Update (Int3 playerColumnId)
//	{
//		if (jobMngrIncomingEvents->GetJobCount () == 0 && incomingEventsQueue.size () > 0)
//		{
//			CmdBase * cmd = incomingEventsQueue.front ();
//			incomingEventsQueue.pop_front ();
//			cmd->AddToQueue (Thread::JB_NORMAL);
//		}
//
//		jobMngrIncomingEvents->MainThread_Update ();
//
//		if (jobMngrGfxBuilder->GetJobCount () == 0)
//		{
//			if (requiresGfxColl.size () > 0)
//			{
//				std::sort (requiresGfxColl.begin (), requiresGfxColl.end (), CompareFunction (playerColumnId));
//
//				int neighboursNeeded = 4;
//				//for (int neighboursNeeded = 4; neighboursNeeded > 0; --neighboursNeeded)
//				{
//					//std::sort (requiresGfxColl.begin (), requiresGfxColl.end (), ReverseSort ());
//					for (int idx = 0; idx < requiresGfxColl.size (); ++idx)
//					{
//						Int3 columnId = requiresGfxColl [idx];
//
//						SceneSim::Room * simRoom = GetSimWorld ()->GetRoom ("hub");
//						assert (simRoom != NULL);
//
//						int neighboursFound = 0;
//						neighboursFound += (simRoom->GetColumn (columnId + Int3 (0, 0, 1)) != NULL) ? 1 : 0;
//						neighboursFound += (simRoom->GetColumn (columnId + Int3 (1, 0, 0)) != NULL) ? 1 : 0;
//						neighboursFound += (simRoom->GetColumn (columnId + Int3 (0, 0, -1)) != NULL) ? 1 : 0;
//						neighboursFound += (simRoom->GetColumn (columnId + Int3 (-1, 0, 0)) != NULL) ? 1 : 0;
//						if (neighboursFound == neighboursNeeded)
//						{
//							RemoveGfxRequired (columnId);
//
//							aah_new CmdsGfx::ColumnGfxCreate (this, "hub", columnId);
//						
//							neighboursNeeded = 0;
//							break;
//						}
//					}
//				}
//			}
//		}
//
//		jobMngrGfxBuilder->MainThread_Update ();
//	}
//
//	void SceneChangeMngr::AddIncomingCmd (CmdBase * cmd)
//	{
//		assert (cmd != NULL);
//
//		cmd->AddToQueue (Thread::JB_NORMAL);
//	}
//
//	void SceneChangeMngr::AddGfxBuilderCmd (CmdBase * cmd)
//	{
//		assert (cmd != NULL);
//
//		incomingEventsQueue.push_back (cmd);
//	}
//
//	void SceneChangeMngr::AddGfxRequired (Int3 columnId)
//	{
//		requiresGfxColl.push_back (columnId);
//	}
//
//	void SceneChangeMngr::RemoveGfxRequired (Int3 columnId)
//	{
//		for (int idx = 0; idx < requiresGfxColl.size (); ++idx)
//		{
//			if (requiresGfxColl [idx] == columnId)
//			{
//				if (idx < (requiresGfxColl.size () - 1))
//				{
//					requiresGfxColl [idx] = requiresGfxColl.back ();
//				}
//				requiresGfxColl.pop_back ();
//				break;
//			}
//			//assert (idx != requiresGfxColl.size ()); // assert not needed - safe to call this on any column id
//		}
//	}
//}
