#pragma once

namespace Gfx {namespace Buffers {class PointList;}}
namespace Gfx {namespace VertexTypes {struct Xyz;}}
namespace SceneGfx {class Room;}
namespace SceneSim {class AreaLow;}

namespace SceneGfx
{
	class AreaLow
	{
	public:

		AreaLow (Room * room, SceneSim::AreaLow * areaLow);
		~AreaLow ();

		void CopyToGfxCardIfNeeded ();

		void Update ();
		void Render (int passIdx, Int3 columnId, Vec3 colRelPos);

	private:
		
		Room * const room;
		SceneSim::AreaLow * const simAreaLow;

		bool copyToGfxCardIfNeeded;

		Gfx::VertexTypes::Xyz * verts;
		Gfx::Buffers::PointList * buffer;
		int vertsTotal;
	};
}
