#include "stdafx.h"

#include "SceneGfx_BlockChangeList.h"

namespace SceneGfx
{
	void BlockChangeList::AddEntry (Int3 columnId, int blockIdsAsBits)
	{
		for (int idx = 0; idx < entries.size (); ++idx)
		{
			if (entries [idx].columnId == columnId)
			{
				entries [idx].blockIdsAsBits |= blockIdsAsBits;
				return;
			}
		}
		entries.push_back (ColumnBlockBits (columnId, blockIdsAsBits));
	}

	const std::vector <ColumnBlockBits> & BlockChangeList::GetEntries () const
	{
		return entries;
	}
}
