#include "stdafx.h"

#include "SceneGfx_Block.h"
#include "SceneGfx_Column.h"
#include "SceneGfx_JobCreateBlockMesh.h"

namespace SceneGfx
{
	JobCreateBlockMesh::JobCreateBlockMesh 
	(
		Thread::JobMngr * jobMngr, 
		Column * column,
		int blockId,
		Thread::SafeList <JobCreateBlockMesh *> * list
	)
		: Job (jobMngr),
		column (column),
		blockId (blockId),
		list (list),
		block (NULL)
	{
		assert (false); // use JobCreateBlockMeshes now

		assert (column != NULL);
		assert (list != NULL);

		list->PushBack (this);
	}

	Thread::JOBSTATES JobCreateBlockMesh::JobDoWork ()
	{
		assert (false);
		//block = aah_new Block (column, blockId);
		return Thread::JS_WORKDONE;
	}

	Thread::JOBSTATES JobCreateBlockMesh::JobOnCompleted ()
	{
		Job::JobOnCompleted ();

		list->Remove (this);

		assert (false);

		//--column->jobsOutstandingCount;
		//if (column->jobsOutstandingCount == 0 && column->markAsDead)
		//{
		//	delete column;
		//	delete block;
		//}
		//else
		//{
		//	column->AddOrReplaceBlock (block);
		//}

		return Thread::JS_COMPLETED;
	}
}
