#include "stdafx.h"

#include "Lua/Lua_LuaState.h"

#include "../Gfx/Gfx_Tex.h"

#include "SceneGfx_TexMngr.h"

namespace SceneGfx
{
	TexMngr::TexMngr (Lua::LuaState * worldLua, TextRef path)
	{
		//assert (worldLua != NULL);

		texTotal = 1;
		texs = aah_new Gfx::GfxTex * [texTotal];
	
		//TODO:
		//texs [0] = aah_new Gfx::GfxTex (worldLua->ReadString (path + "/texture"));
		texs [0] = aah_new Gfx::GfxTex ("gfx/terrain_inprogress_00.png");
	}

	TexMngr::~TexMngr ()
	{
		for (int i = 0; i < texTotal; ++i)
		{
			delete texs [i];
		}
		delete [] texs;
	}

	void TexMngr::Bind (int idx)
	{
		assert (idx >= 0 && idx < texTotal);
		texs [idx]->Bind ();
	}

	void TexMngr::Unbind (int idx)
	{
		assert (idx >= 0 && idx < texTotal);
		texs [idx]->Unbind ();
	}

	void TexMngr::UpdateAnims ()
	{
		//assert (false);
	}

}
