#pragma once

namespace Gfx {class GfxTex;}
namespace Lua {class LuaState;}

namespace SceneGfx
{
	class TexMngr
	{
	public:
		TexMngr (Lua::LuaState * worldLua, TextRef path);
		~TexMngr ();

		void Bind (int idx);
		void Unbind (int idx);

		void UpdateAnims ();

	private:
		Gfx::GfxTex * * texs;
		int texTotal;
	};
}
