#pragma once

namespace Ld {class ColumnMask;}
namespace SceneGfx {class Column;}
namespace SceneGfx {class Room;}
namespace SceneSim {class Column;}
namespace SceneSim {class Room;}
namespace SceneSim {class World;}
namespace Thread {class JobMngr;}

namespace SceneGfx
{
	class World
	{
	public:

		World ();
		~World ();

		void Update ();
		void Render (int passIdx, Ld::ColumnMask * mask, Int3 columnId, Vec3 colRelPos, int drawDistance, Int3 offset);

		void OnLoadCompleted (SceneSim::World * simWorld);

		void SetPrimaryRoom (Room * room);
		Room * GetPrimaryRoom () const;
		void ClearPrimaryRoom ();

	private:

		Room * roomPrimary;

		SceneSim::World * simWorld;
	};
}
