#include "stdafx.h"

#include "../SceneSim/SceneSim_Defs.h"

#include "Collision_Box_Cell.h"

namespace Collision
{
	bool Box_Cell (Int3 columnId, Vec3 bl1, Vec3 tr1, SceneSim::Room * room, Int3 columnId2, Int3 cellId2)
	{
		columnId2 -= columnId;
		Vec3 bl2 (
			cellId2.x + columnId2.x * SceneSim::CellsPerColXz,
			cellId2.y + columnId2.y * SceneSim::CellsPerColY,
			cellId2.z + columnId2.z * SceneSim::CellsPerColXz);

		Vec3 tr2 (bl2 + Vec3 (1.0f, 1.0f, 1.0f));

        return (bl1.x < tr2.x && bl1.y < tr2.y && bl1.z < tr2.z && tr1.x > bl2.x && tr1.y > bl2.y && tr1.z > bl2.z);
	}
}