#pragma once

namespace CellBuilder {class Mngr;}
namespace CsgEffect {class ColumnChanges;}
namespace SceneSim {class Column;}

namespace CsgEffect
{
	class CsgEffectBase
	{
	public:
		
		virtual ~CsgEffectBase () {}

		virtual int GetColumnAffectedCount () const = 0;
		virtual Int3 GetColumnIdAffected (int nth) const = 0;

		virtual void ApplyChanges (int nth, SceneSim::Column * column, const CellBuilder::Mngr * cellBuilder, ColumnChanges * changes) = 0;

	private:

	};
}
