#pragma once

#include "../Ld/Ld_ColumnMask.h"

#include "Comps_Coord.h"
#include "Comps_Motion.h"
#include "Comps_Orient.h"
#include "Ents_Base.h"

namespace SceneSim {class Room;}

namespace Ents
{
	class CMO_Box : public Base
	{
	public:

		CMO_Box ();
		CMO_Box (int id);
		virtual ~CMO_Box ();

		void Update (float timeStep, SceneSim::Room * room, bool canClimb, Ld::ColumnMask * mask);

		bool IsOverlapping (SceneSim::Room * room, Int3 columnId, Int3 cellId) const;

		Comps::Coord coord;
		Comps::Motion motion;
		Comps::Orient orient;

		unsigned int motionResult;
	};
}
