#pragma once

namespace Input
{
	class SingleInput
	{
	public:

		SingleInput ();

		bool IsOn () const;
		bool IsJustOn () const;
		float TimeSinceToggle (float timeNow) const;

		void SetIsOn (bool isOn, float timeNow, char debug = 0);

		void Update ();

	private:

		bool isOn;
		bool lastIsOn;
		bool wasOn;
		float toggleTime;
	};
}