#include "stdafx.h"

#include "Utils/Utils_Math.h"

#include "../SceneCollections/SceneCollections_Utils.h"

#include "SceneFile_Focus.h"

namespace SceneFile
{
	void Focus::SetIsValid (bool isValid) 
	{
		assert (isValid); // havent coded handling turning off for a while yet
		this->isValid = isValid;
	}

	Focus::Focus () : loadRadius (0), unloadRadius (0), isValid (false), isPrevValid (false) 
	{
	}

	Focus::~Focus () 
	{
	}

	void Focus::CalculateCoverage ()
	{
//		assert (isValid);
//		assert (loadRadius > 0 && unloadRadius >= loadRadius);
//		assert (!isPrevValid || prevRoomId == roomId); // cant handle changing rooms yet
//
//		const int loadRadiusSqr = loadRadius * loadRadius;
//		const int unloadRadiusSqr = unloadRadius * unloadRadius;
//
//		justCovered.clear ();
//		justUncovered.clear ();
//
//		// go over all currently covered - see if any need moving to uncovered
//
//		for (SceneCollections::ColumnVectorIt current = coveringNow.begin (); current != coveringNow.end (); )
//		{
//			Int3 searchId (*current);
//			int lengthSqr = Utils::LengthSqr (searchId - columnId);
//			if (lengthSqr > unloadRadiusSqr)
//			{
//				current = coveringNow.erase (current);
//				justUncovered.push_back (searchId);
//			}
//			else
//			{
//				++current;
//			}
//		}
//
//		// go over all that are covered to find new ones
//
//		Int3 searchId (0, 0, 0);
//		for (searchId.x = columnId.x - loadRadius; searchId.x <= columnId.x + loadRadius; ++searchId.x)
//		{
//			//for (searchId.y = columnId.y - loadRadius; searchId.y <= columnId.y + loadRadius; ++searchId.y)
//			//{
//				for (searchId.z = columnId.z - loadRadius; searchId.z <= columnId.z + loadRadius; ++searchId.z)
//				{
//					int lengthSqr = Utils::LengthSqr (searchId - columnId);
//					if (lengthSqr <= loadRadiusSqr && !SceneCollections::Contains (&coveringNow, searchId))
//					{
//						coveringNow.push_back (searchId);
//						justCovered.push_back (searchId);
//					}
//				}
////			}
//		}

		prevRoomId = roomId;
		prevColumnId = columnId;
		prevColumnPos = columnPos;
	}
}
