//#pragma once
//
//#include <vector>
//
//#include "../SceneCollections/SceneCollections_SparseObjGrid.h"
//
//#include "SceneFile_Focus.h"
//#include "SceneFile_FocusTrackerCell.h"
//
//namespace SceneFile {class SimFactory;}
//namespace SceneHelper {class SimEvents;}
//namespace SceneHelper {class SimMngr;}
//namespace SceneSim {class Column;}
//namespace SceneSim {class Room;}
//namespace SceneSim {class World;}
//namespace SceneSim {class WorldInit;}
//
//namespace SceneFile
//{
//	class FocusMngr
//	{
//	public:
//
//		FocusMngr (SceneSim::WorldInit * worldInit, SceneSim::World * world, SceneHelper::SimEvents * events);
//		~FocusMngr ();
//
//		Focus * GetNewFocus ();
//		void ReleaseFocus (Focus * focus);
//
//		void Update ();
//
//		int Temp_GetFocusRadius () const; // being used currently for getting column distance for the world tracker (needs sorting)
//
//	private:
//
//		typedef std::vector <Focus *> FocusColl;
//
//		void ReleaseFocii (FocusColl * coll);
//		void UpdateTrackedCells (SceneSim::Room * room, SceneCollections::ColumnIdVector * ids, bool isAdding);
//		void UpdateLoadsAroundFocii ();
//		void UpdateUnloadsAroundFocii ();
//
//		bool IsWorldUnloaded () const;
//		void AttemptWorldLoad ();
//		bool IsWorldReady () const;
//		void ReadWorldData ();
//		bool GetNextColumnToLoad (SceneSim::Room * room, const Focus * focus, Int3 * outColumnId, float * outColumnDistSqr) const;
//
//		SceneSim::World * world;
//		SimFactory * factory;
//
//		bool hasReadWorldData;
//
//		int loadColumnRadius;
//		
//		FocusColl focii;
//		FocusColl fociiReleased;
//
//		//SceneCollections::SparseObjGrid <FocusTrackerCell> cellTracker;
//	};
//}
