#include "stdafx.h"

#include "Gen00_WorldOps.h"
#include "SceneFile_Operations.h"
#include "SceneFile_OpMngr.h"

namespace SceneFile
{
	OpMngr::OpMngr ()
	{
		worldOps.create = Gen00::Gen00_WorldCreate;
		worldOps.load = Gen00::Gen00_WorldLoad;
		worldOps.save = NULL;
	}

	OpMngr::~OpMngr ()
	{
	}

	const Operations * OpMngr::GetWorldOps (int version) const
	{
		assert (version == 0);
		return &worldOps;
	}
}
