// stdafx.h : include file for standard system include files,
// or project specific include files that are used frequently, but
// are changed infrequently
//

#pragma once

#include "targetver.h"
#include "Globals/Globals_Defs.h"

#define WIN32_LEAN_AND_MEAN             // Exclude rarely-used stuff from Windows headers

#include <windows.h>

// TODO: reference additional headers your program requires here

#include <iostream>
#include <assert.h>

#include "SDL/SDL-1.2.14 sdk/include/SDL_opengl.h" 
#include "SDL/SDL-1.2.14 sdk/include/SDL_thread.h"
#include "SDL/SDL-1.2.14 sdk/include/SDL_timer.h"
#include "SDL/SDL-1.2.14 sdk/include/SDL_mutex.h"

//
#include "ExternalLibs/glm-0.9.1.2/glm/gtc/matrix_transform.hpp"
#include "ExternalLibs/glm-0.9.1.2/glm/gtx/norm.hpp"

#include "Globals/Globals_Types.h"
#include "Utils/Utils_Compress.h"
#include "Utils/Utils_Debug.h"
#include "Utils/Utils_File.h"
#include "Utils/Utils_Math.h"

#include "Mem/Mem_Alloc.h"
#include "Mem/Mem_Context.h"

using namespace Utils;
