//#pragma once
//
//#include "File_PakFileBase.h"
//
//namespace File {struct PakFileRecord;}
//namespace Utils {struct Time;}
//
//namespace File
//{
//	class PakFile : public PakFileBase
//	{
//	public:
//
//		PakFile (TextRef filename, int recordCount);
//		virtual ~PakFile ();
//
//		bool DoesRecordExist (int recordIdx) const;
//
//		virtual int LoadRecord (int recordIdx, RakNet::Time * lastModified, unsigned char * out, int maxOut) = 0;
//
//		virtual void SaveRecord (int recordIdx, const RakNet::Time * lastModified, unsigned char * in, int size) = 0;
//
//		unsigned int Debug_GetChecksum (int recordIdx, unsigned char * data, int length) const;
//
//	private:
//
//		static const int blockSize = 1024 * 4; // any benefit to matching cluster size?
//
//		void InitNewHeader (int recordCount);
//		void SaveHeader (bool addPadding);
//
//		int GetMinBlockCount (int size) const;
//		void PadToNextBlock (std::fstream * file);
//		int FindFirstFreeBlocks (int blockCount) const;
//		
//		static unsigned char padBuffer [blockSize];
//
//		Text filename;
//
//		PakFileHeader header;
//		PakFileRecord * records;
//
//		int * sortedRecordIds;
//	};
//}
