#pragma once

#if !defined (_DEBUG_MEMORYTEST)
//#	define PROFILER_ENABLE
#endif

namespace Profile {class ProfileThread;}

namespace Profile
{
	class ProfileApp
	{
	public:

		static void Init ();
		static void Exit ();
		static void Update ();

		static void RegisterThread (const char * name);

		static ProfileThread * FindThread ();
		static ProfileThread * GetThreadByIdx (int idx);

		static void ReportToScreen (const char * title);

	private:

		ProfileApp ();
	};
}
