#include "stdafx.h"

#include "Profile_ProfileApp.h"
#include "Profile_ProfileScope.h"
#include "Profile_ProfileThread.h"

namespace Profile
{
	ProfileScope::ProfileScope (ProfileThread * profiler, int recordId)
		: profiler (profiler),
		recordId (recordId)
	{
		profiler->RecordScope (recordId);
	}

	ProfileScope::~ProfileScope ()
	{
		profiler->StopScope (recordId);
	}
}
