#include "stdafx.h"

#include "Profile_Record.h"

namespace Profile
{
	Record::Record ()
		: name (NULL)
	{
	}

	Record::~Record ()
	{
		delete [] name;
	}

	void Record::Reset (const char * name, int r, int g, int b)
	{
		delete [] this->name;
		this->name = strdup (name);
		calledCount = 0;

		this->r = r;
		this->g = g;
		this->b = b;

		start.QuadPart = -1;
		cumulative = 0.0f;
		longest = 0.0f;
		mostRecent = 0.0f;

		memset (history, 0, sizeof (history));
	}
}
