#pragma once

namespace Utils
{
	class AppVersion
	{
	public:

		enum VersionTypes
		{
			VT_LUDUMDARE23,
		};

		AppVersion ()
			: type (AppVersion::VT_LUDUMDARE23),
			major (0),
			minor (2)
		{
		}

		AppVersion (VersionTypes type, unsigned char major, unsigned char minor)
			: type (type),
			major (major),
			minor (minor)
		{
		}

		Text ToText () const;

		const unsigned char type;
		const unsigned char major;
		const unsigned char minor;
	};
}
