#pragma once

#include <vector>

namespace Utils
{
	extern Text File_NeatenFolder (TextRef folder);

	extern bool File_Exists (TextRef filename);
	extern bool File_CreateDirTree (TextRef path);
	extern bool File_CopyFile (TextRef destFile, TextRef srcFile, bool overwriteExisting);
	extern bool File_CopyFolder (TextRef destFolder, TextRef srcFolder, bool overwriteExisting);
	
	extern void File_ListFolders (TextRef folderToScan, std::vector <Text> * results);
}
