#pragma once

namespace RakNet
{
	struct Time 
	{
		Time () {t.QuadPart = 0LL;}
		Time (LONGLONG t) {this->t.QuadPart = t;}

		bool operator > (const Time & o) const		{return (t.QuadPart > o.t.QuadPart);}
		bool operator >= (const Time & o) const		{return (t.QuadPart >= o.t.QuadPart);}
		Time operator / (LONGLONG o) const			{return Time (t.QuadPart / o);}
		bool operator != (const Time & o) const		{return (t.QuadPart != o.t.QuadPart);}
		bool operator != (LONGLONG o) const		{return (t.QuadPart != o);}
		Time operator - (const Time & o) const		{return Time (t.QuadPart - o.t.QuadPart);}
		Time & operator += (const Time & o)			{t.QuadPart += o.t.QuadPart; return *this;}
		Time & operator -= (const Time & o)			{t.QuadPart -= o.t.QuadPart; return *this;}

		operator float () const						{return (float)t.QuadPart;}

		LARGE_INTEGER t;
	};

	extern Time GetTime ();
	extern Time GetTimeTicksPerSecond ();
}
