#include "stdafx.h"

#include "Gfx/Gfx_Font.h"
#include "Plot/Plot_Prims.h"

#include "Menus_Draw.h"

namespace Menus
{
	void Draw_Box (Int2 tl, Int2 size, Int4 fill)
	{
		Plot::Prims_Quad (tl, tl + size, fill);
	}

	void Draw_BoxOutline (Int2 tl, Int2 size, int borderSize, Int4 border, Int4 fill)
	{
		Int2 one (1, 1);
		Draw_Box (tl, size, border);
		Draw_Box (tl + one * borderSize, size - one * borderSize * 2, fill);
	}

	void Draw_Text (Int2 tl, const char * text, Gfx::Font * font)
	{
		assert (text != NULL);
		assert (font != NULL);

		font->DrawString (text, tl.x, tl.y); 
	}
}
