#pragma once

namespace Menus
{
	struct Palette
	{
		Int2 labelSize; // size of label
		Int2 labelControl; // gap from label tl to control tl
		Int2 textOffset; // offset from any box to text draw position
		Int2 vertSpacing; // vertical spacing between controls
		Int2 centreLabelPos; // gap from left to centred label

		int thickness; // border thickness
		Int4 border; // border colour
		Int4 fill; // fill colour
		Int4 pageBg;

		Int4 highlight;
	};

	extern const Palette * Palette_Get (bool isFocused);
}
