#pragma once

#include "Tiny_TinyWorlds.h"

namespace SceneGfx {class World;}

namespace Tiny
{
	class TinyWorld
	{
	public:
		
		TinyWorld (TINYNAMES name, char * title, Vec3 pos, Int3 * source, int sourceCount, SceneGfx::World * gfxWorld);
		~TinyWorld ();

		void Update ();
		void Render ();

		const TINYNAMES name;
		Vec3 pos;
		Int3 * source;
		int sourceCount;

		SceneGfx::World * gfxWorld;
		char * title;
	};
}