#pragma once

namespace Gfx {namespace VertexTypes {struct Xyz;}}

namespace Gfx
{
	namespace Buffers
	{
		class PointList
		{
		public:

			PointList ();
			~PointList ();

			void SetVerts (const VertexTypes::Xyz * data, int vertsCount);

			void Render ();

		private:

			GLuint vboId;

			int vertsCount;
		};
	}
}
