#pragma once

namespace Gfx {namespace VertexTypes {struct XyzUvRgb;}}

namespace Gfx
{
	namespace Buffers
	{
		class TriList
		{
		public:

			TriList ();
			~TriList ();

			void SetVerts (const VertexTypes::XyzUvRgb * data, int vertsCount);

			void Render ();

		private:

			GLuint vboId;

			int vertsCount;
		};
	}
}
