#pragma once

namespace Gfx
{
	namespace VertexTypes
	{
		enum FORMATFLAGS
		{
			FF_XYZ	= 1 << 0,
			FF_RGB	= 1 << 1,
		};

		struct Xyz
		{
			static const int FormatFlags = FF_XYZ | FF_RGB;

			void Set (Vec3 xyz, Vec4 rgba)
			{
				this->xyz = xyz;
				this->rgba = rgba;
			}

			Vec3 xyz;
			Vec4 rgba;

			float pad [1];
		};
	}
}
