#pragma once

namespace Gfx
{
	namespace VertexTypes
	{
		enum FORMATFLAGS
		{
			FF_XYZ	= 1 << 0,
			FF_UV	= 1 << 1,
			FF_RGB	= 1 << 2,
		};

		struct XyzUvRgb
		{
			static const int FormatFlags = (FF_XYZ | FF_UV | FF_RGB);

			void Set (Vec3 xyz, Vec2 uv, Vec4 rgba)
			{
				this->xyz = xyz;
				this->uv = uv;
				this->rgba = rgba;
			}

			Vec3 xyz;
			Vec2 uv;
			Vec4 rgba;

			float pad [3];
		};
	}
}
