#pragma once

#include "SceneSim/SceneSim_Defs.h"
#include "Thread/Thread_Job.h"

namespace SceneChange {class CreateBlockMeshes;}
namespace SceneSim {class Column;}

namespace GfxFactory
{
	class JobCreateBlockMeshes : public Thread::Job
	{
	public:

		JobCreateBlockMeshes (Thread::JobMngr * jobMngr, SceneGfx::Room * gfxRoom, Int3 columnId);
		virtual ~JobCreateBlockMeshes ();

	protected:

		virtual Thread::JOBSTATES JobDoWork ();
		virtual Thread::JOBSTATES JobOnCompleted ();

	private:

		SceneGfx::Room * gfxRoom;
		Int3 columnId;

		SceneSim::AdjColumns columns;

		SceneChange::CreateBlockMeshes * blockCreater;
	};
}
