#pragma once

#include "Utils/Utils_Debug.h"

namespace Gfx {class Font;}

namespace Debug
{
	class DebugStream_Gfx : public DebugStream
	{
	public:

		DebugStream_Gfx (Gfx::Font * font, int stringsMax, int x, int y);
		virtual ~DebugStream_Gfx ();

		virtual void WriteLine (const char * str);
		virtual void Flush ();

		virtual void Clear ();

	private:
		
		Gfx::Font * font;

		static const int stringsLength = 128;
		const int stringsMax;
		int stringsIdx;
		char * strings;

		const int startX;
		const int startY;
	};
}
