#pragma once

namespace Gfx {class GfxTex;}
namespace Particles {class Billboard;}

namespace Particles
{
	class BillboardMngr
	{
	public:

		BillboardMngr (int instancesMax);
		~BillboardMngr ();

		Billboard * GetFree (int texId);

		void Update (float timeDelta);
		void Render (Int3 fromColumnId, Vec3 right, Vec3 up, Vec3 in);

		void CreateExplosion (int seed, Int3 columnId, Vec3 columnPos, float radius, Int4 rgba);

	private:

		const int instancesMax;
		Billboard * instances;

		Gfx::GfxTex * tex;
	};
}
