#pragma once 

namespace Gfx {class GfxTex;}
namespace Input {class InputMngr;}

namespace Plot
{
	enum PRIMTYPES
	{
		PT_NONE,
		PT_XYRGB,
		PT_XYUVRGB,
	};

	extern void Prims_Init (Input::InputMngr * inputMngr);
	extern void Prims_BatchBegin (PRIMTYPES primType);
	extern void Prims_BatchEnd ();
	extern void Prims_Quad (Int2 tl, Int2 br, Int4 rgba);
	extern void Prims_QuadTex (Int2 tl, Gfx::GfxTex * tex);
	extern void Prims_QuadTex (Int2 tl, Gfx::GfxTex * tex, int scale);
	extern void Prims_QuadTex (Int2 tl, Int2 br, Vec2 tlUv, Vec2 brUv, Int4 rgba);
}
