#pragma once

#include "SceneSim/SceneSim_Defs.h"

namespace SceneGfx {class Block;}
namespace SceneGfx {class Room;}
namespace SceneSim {class Column;}

namespace SceneChange
{
	class CreateBlockMeshes 
	{
	public:
		CreateBlockMeshes (const SceneGfx::Room * room, const SceneSim::AdjColumns * adjColumns);

		~CreateBlockMeshes ();

		const SceneSim::Column * GetColumnSrc () const;
		SceneGfx::Block * * GetOutput (int * outputCount) const;

	private:

		int blockIdsAsBits;
		SceneSim::AdjColumns columns;
		
		int blockChangesCount;
		SceneGfx::Block * * blocks;
	};
}
