//#pragma once
//
//#include <list>
//#include <deque>
//#include <vector>
//
//namespace SceneChange {class CmdBase;}
//namespace SceneChange {struct ColumnData;}
//namespace SceneChange {class ColumnDataCollection;}
//namespace SceneGfx {class World;}
//namespace SceneSim {class World;}
//namespace Thread {class JobMngr;}
//
//namespace SceneChange
//{
//	class SceneChangeMngr
//	{
//	public:
//
//		//typedef std::list <CmdBase *> CmdList;
//		//typedef CmdList::iterator CmdListIt;
//
//		SceneChangeMngr (SceneGfx::World * gfxWorld, SceneSim::World * simWorld);
//		~SceneChangeMngr ();
//
//		SceneGfx::World * GetGfxWorld () const;
//		SceneSim::World * GetSimWorld () const;
//		Thread::JobMngr * GetJobMngrIncomingEvents () const;
//		Thread::JobMngr * GetJobMngrGfxBuilder () const;
//		
//		void CreateColumnData (Int3 columnId, ColumnData * columnData);
//		bool GetColumnData (Int3 columnId, ColumnData * columnData) const;
//		bool GetColumnData (Int3 columnId, ColumnData * columnData);
//		void SetColumnData (Int3 columnId, const ColumnData * columnData);
//		void DeleteColumnData (Int3 columnId);
//
//		void Update (Int3 playerColumnId);
//
//		void AddIncomingCmd (CmdBase * cmd);
//
//		void AddGfxBuilderCmd (CmdBase * cmd);
//		void AddGfxRequired (Int3 columnId);
//		void RemoveGfxRequired (Int3 columnId);
//
//	private:
//
//		SceneGfx::World * gfxWorld;
//		SceneSim::World * simWorld;
//		
//		Thread::JobMngr * jobMngrIncomingEvents;
//		Thread::JobMngr * jobMngrGfxBuilder;
//
//		//ColumnDataCollection * columnDataColl;
//		//SceneCollections::SparseObjGrid <ColumnData> columnDataColl;
//		ColumnData * columnDataColl;
//
//		std::deque <CmdBase *> incomingEventsQueue;
//		std::vector <Int3> requiresGfxColl;
//		
//		mutable SDL_mutex * lock;
//
//		//CmdList cmds;
//	};
//}
