#pragma once

#include <vector>

#include "SceneGfx_ColumnBlockBits.h"

namespace SceneGfx
{
	class BlockChangeList
	{
	public:

		typedef std::vector <ColumnBlockBits> EntryColl;
		typedef EntryColl::const_iterator EntryCollCit;

		void AddEntry (Int3 columnId, int blockIdsAsBits);
		
		const EntryColl & GetEntries () const;

	private:

		EntryColl entries;
	};
}
