#include "stdafx.h"

#include "../CellBuilder/CellBuilder_Mngr.h"
#include "../CellBuilder/CellBuilder_ShapeInitData.h"
//#include "../Gfx/VertexTypes_XyzUvRgb.h"
//#include "../SceneGfx/SceneGfx_Column.h"
//#include "../SceneGfx/SceneGfx_Room.h"
#include "../SceneSim/Query_Cell.h"
#include "../SceneSim/SceneSim_Cell.h"
#include "../SceneSim/SceneSim_Column.h"
#include "../SceneSim/SceneSim_Room.h"

#include "CellBuilder_ShapeBase.h"

using namespace SceneSim;

namespace CellBuilder
{
	ShapeBase::ShapeBase ()
		: entCollisions (EC_UNITCUBE),
		blocksLight (true)
	{
	}

	ShapeBase::~ShapeBase ()
	{
	}

	void ShapeBase::Set (SceneSim::ENTCOLLISIONS entCollisions, bool blocksLight)
	{
		this->entCollisions = entCollisions;
		this->blocksLight = blocksLight;
	}
}
