#include "stdafx.h"

#if 0

#include "../SceneSim/SceneSim_Cell.h"

#include "Collision_Segment_Block.h"
#include "Collision_Segment_Cube.h"
#include "Collision_Result.h"

namespace Collision
{
	bool Segment_Block (Vec3 segPos, Vec3 segDir, SceneSim::Block * block, Result * result)
	{
		result->Clear ();

		Result tempResult;

		for (int x = 0; x < SceneSim::CellsPerColXz; ++x)
		{
			for (int y = 0; y < SceneSim::CellsPerColXz; ++y)
			{
				for (int z = 0; z < SceneSim::CellsPerColXz; ++z)
				{
					const SceneSim::Cell * cell = block->GetCell (x, y, z);
					//if (block->CanBlockGfxFaces (x, y, z))
					if (cell->type != SceneSim::AIR)
					{
						if (Segment_Cube (segPos, segDir, Vec3 (x, y, z), Vec3 (x + 1, y + 1, z + 1), &tempResult))
						{
							if (!result->isColliding || tempResult.entryTime < result->entryTime)
							{
								*result = tempResult;
								result->resultFlags |= RF_ENTRYCELL;
								result->entryCell = Int3 (x, y, z);
							}
						}
					}
				}
			}
		}

		return result->isColliding;
	}
}

#endif 