#pragma once

namespace Gfx {class Viewport;}

namespace Gfx
{
	class Camera
	{
	public:

		Camera (const Viewport * viewport);

		void Apply ();

		void CalcProjectionMatrix ();
		void CalcViewMatrix ();
		
		Vec3 xyz;
		Vec3 ypr;

		float clipNear;
		float clipFar;

		Int2 viewportSize;
		Mat44 matProjection;
		Mat44 matView;
	};
}
