#pragma once

namespace Noise {struct Seed;}

namespace Noise
{
	struct PerlinParams
	{
		float scale;
		int octavesMax;
		float frequencyPerOctave;
		float amplitudePerOctave;
	};

	extern float Perlin2d (const Seed & seed, float x, float y, const PerlinParams * params);
	extern float Perlin2d (const Seed & seed, float x, float y, float * octaveWeights);

	extern float Perlin3d (const Seed & seed, float x, float y, float z, const PerlinParams * params);
}
