#pragma once

namespace Noise
{
	struct Seed
	{
		Seed (int s) : s (s) {}

		int s;
	};

	extern int RandomInt (const Seed & seed, int x);

	extern float Random (const Seed & seed, int x);
	extern float Random (const Seed & seed, int x, int y);

	extern float RandomInterpolated (const Seed & seed, float x, float y);
	extern float RandomInterpolated (const Seed & seed, float x, float y, float z);

	extern float EaseInEaseOut (const Seed & seed, float in);
}
