#pragma once

namespace SceneFile {namespace Area {class AreaInstance;}}
namespace SceneSim {class Column;}

namespace SceneFile
{
	namespace Area
	{
		class AreaMngr
		{
		public:

			AreaMngr (TextRef fileFolder);
			~AreaMngr ();

			bool IsColumnLoadable (Int3 columnId);

			void LoadColumn_BaseData (SceneSim::Column * column);

			void SaveColumn (SceneSim::Column * column);

		private:

			AreaInstance * GetOrCreate (Int3 columnId);

			AreaInstance * instance;

			const Text fileFolder;
		};
	}
}
