#pragma once

#include "../SceneCollections/SceneCollections_ColumnIdVector.h"

namespace SceneFile {class FocusMngr;}

namespace SceneFile
{
	class Focus
	{
	public: 

		void SetIsValid (bool isValid);

		int loadRadius;
		int unloadRadius;

		Text roomId;
		Int3 columnId;
		Vec3 columnPos;

	private:

		friend class FocusMngr;

		Focus ();
		~Focus ();

		void CalculateCoverage ();

		bool isValid;
		bool isPrevValid;
	
		Text prevRoomId;
		Int3 prevColumnId;
		Vec3 prevColumnPos;

		//SceneCollections::ColumnIdVector coveredAndLoaded;
		//SceneCollections::ColumnIdVector uncoveredAndLoaded;

		SceneCollections::ColumnIdVector justCovered;
		SceneCollections::ColumnIdVector coveringNow;
		SceneCollections::ColumnIdVector justUncovered;
	};
}
