#include "stdafx.h"
//
//#include "Lua/Lua_LuaState.h"
//
//#include "../SceneCollections/SceneCollections_Utils.h"
//#include "../SceneHelper/SceneHelper_Helper.h"
//#include "../SceneHelper/SceneHelper_SimMngr.h"
//#include "../SceneSim/SceneSim_Column.h"
//#include "../SceneSim/SceneSim_Room.h"
//#include "../SceneSim/SceneSim_World.h"
//
//#include "SceneFile_FocusMngr.h"
//#include "SceneFile_SimFactory.h"
//
//namespace SceneFile
//{
//	FocusMngr::FocusMngr (SceneSim::WorldInit * worldInit, SceneSim::World * world, SceneHelper::SimEvents * events)
//		: world (world),
//		hasReadWorldData (false),
//		loadColumnRadius (-1)
//	{
//		factory = aah_new SimFactory (world, events);
//	}
//
//	FocusMngr::~FocusMngr ()
//	{
//		ReleaseFocii (&focii);
//		ReleaseFocii (&fociiReleased);
//
//		assert (focii.size () == 0);
//		assert (fociiReleased.size () == 0);
//		delete factory;
//	}
//
//	Focus * FocusMngr::GetNewFocus ()
//	{
//		Focus * focus = aah_new Focus ();
//		focii.push_back (focus);
//		return focus;
//	}
//
//	void FocusMngr::ReleaseFocus (Focus * focus)
//	{
//		SceneCollections::Remove (&focii, focus);
//		fociiReleased.push_back (focus);
//	}
//
//	void FocusMngr::Update ()
//	{
//		ReleaseFocii (&fociiReleased);
//
//		if (IsWorldUnloaded ())
//		{
//			AttemptWorldLoad ();
//		} 
//		else if (IsWorldReady ())
//		{
//			if (!hasReadWorldData)
//			{
//				ReadWorldData ();
//				hasReadWorldData = true;
//			}
//
//			UpdateLoadsAroundFocii ();
//
//			UpdateUnloadsAroundFocii ();
//		}
//
//		factory->Update ();
//	}
//
//	int FocusMngr::Temp_GetFocusRadius () const
//	{
//		return loadColumnRadius;
//	}
//
//	void FocusMngr::ReleaseFocii (FocusColl * coll)
//	{
//		assert (coll != NULL);
//
//		for (int idx = 0; idx < coll->size (); ++idx)
//		{
//			Focus * focus = (*coll) [idx];
//
//			SceneSim::Room * room = world->GetRoom (focus->roomId);
//			assert (room != NULL);
//	
//			UpdateTrackedCells (room, &focus->coveringNow, false);
//			UpdateTrackedCells (room, &focus->justUncovered, false);
//
//			delete focus;
//		}
//		coll->clear ();
//	}
//
//	void FocusMngr::UpdateTrackedCells (SceneSim::Room * room, SceneCollections::ColumnIdVector * ids, bool isAdding)
//	{
//		return;
//
//		//assert (room != NULL);
//		//assert (ids != NULL);
//
//		//FocusTrackerCell tracker;
//
//		//for (int idx = 0; idx < ids->size (); ++idx)
//		//{
//		//	Int3 id = (*ids) [idx];
//		//	if (isAdding)
//		//	{
//		//		if (!cellTracker.Get (id, &tracker))
//		//		{
//		//			cellTracker.AddRef (id);
//		//			tracker.focusOverlapCount = 1;
//		//		}
//		//		else
//		//		{
//		//			++tracker.focusOverlapCount;
//		//		}
//		//		cellTracker.Set (id, &tracker);
//		//	}
//		//	else
//		//	{
//		//		bool isValid = cellTracker.Get (id, &tracker);
//		//		assert (isValid);
//		//		--tracker.focusOverlapCount;
//		//		if (tracker.focusOverlapCount == 0)
//		//		{
//		//			cellTracker.SubRef (id);
//		//			assert (!cellTracker.Get (id, &tracker));
//
//		//			factory->RequestColumnUnload (id);
//
//		//			//SceneSim::Column * column = SceneHelper::GetColumnFromRoom (room, id);
//		//			//if (column != NULL)
//		//			//{
//		//				//factory->RequestColumnUnload (column);
//		//			//}
//		//		}
//		//		else
//		//		{
//		//			cellTracker.Set (id, &tracker);
//		//		}
//		//	}
//		//}
//	}
//
//	void FocusMngr::UpdateLoadsAroundFocii ()
//	{
//		SceneSim::Room * columnToLoadRoom = NULL;
//		Int3 columnIdToLoad;
//		float columnToLoadDistSqr = -1.0f; // distance from focus - so smaller is better with -1.0f meaning "none selected yet"
//
//		for (int idx = 0; idx < focii.size (); ++idx)
//		{
//			Focus * focus = focii [idx];
//			if (focus->isValid)
//			{
//				focus->loadRadius = loadColumnRadius;
//				focus->unloadRadius = loadColumnRadius + 1;
//
//				focus->CalculateCoverage ();
//
//				if (!world->IsRoomLoaded (focus->roomId))
//				{
//					factory->RequestRoomLoad (focus->roomId);
//				}
//				else
//				{
//					SceneSim::Room * room = world->GetRoom (focus->roomId);
//
//					if (room != NULL)
//					{
//						UpdateTrackedCells (room, &focus->justCovered, true);
//						UpdateTrackedCells (room, &focus->justUncovered, false);
//
//						Int3 focusColumnId;
//						float focusColumnDistSqr = -1.0f;
//						
//						if (GetNextColumnToLoad (room, focus, &focusColumnId, &focusColumnDistSqr))
//						{
//							if (columnToLoadDistSqr == -1.0f || focusColumnDistSqr < columnToLoadDistSqr)
//							{
//								columnToLoadRoom = room;
//								columnToLoadDistSqr = focusColumnDistSqr;
//								columnIdToLoad = focusColumnId;
//							}
//						}
//					}
//				}
//			}
//			else
//			{
//				focus->loadRadius = focus->unloadRadius = -1;
//			}
//		}
//
//		if (columnToLoadDistSqr != -1.0f)
//		{
//			factory->RequestColumnLoad (columnToLoadRoom, columnIdToLoad);
//		}
//	}
//
//	void FocusMngr::UpdateUnloadsAroundFocii ()
//	{
//		const int maxRadiusSqr = loadColumnRadius * loadColumnRadius;
//
//		int roomNth = 0;
//		
//		for (SceneSim::Room * room = world->GetRoomNth (roomNth); room != NULL; room = world->GetRoomNth (roomNth))
//		{
//			int fociiInRoom = 0;
//		
//			int columnNth = 0;
//			for (SceneSim::Column * column = room->GetNthLoadedColumn (columnNth); column != NULL; column = room->GetNthLoadedColumn (columnNth))
//			{
//				int fociiInColumn = 0;
//
//				for (int focusIdx = 0; focusIdx < focii.size (); ++focusIdx)
//				{
//					const Focus * focus = focii [focusIdx];
//					if (focus->roomId == room->roomId)
//					{
//						++fociiInRoom;
//
//						const Int3 delta = column->columnId - focus->columnId;
//						const int distSqr = delta.x * delta.x + delta.z * delta.z;
//
//						if (distSqr <= maxRadiusSqr)
//						{
//							++fociiInColumn;
//						}
//					}
//				}
//				
//				if (fociiInColumn > 0)
//				{
//					++columnNth;
//				}
//				else
//				{
//					// mark column for unloading (should remove it from the rooms column list immediately
//					factory->RequestColumnUnload (column);
//				}
//			}
//			
//			if (fociiInRoom == 0)
//			{
//				//delete the room
//				++roomNth;
//			}
//			else
//			{
//				++roomNth;
//			}
//		}
//	}
//
//	bool FocusMngr::IsWorldUnloaded () const
//	{
//		return (world->loadState == SceneSim::LS_NONE);
//	}
//
//	void FocusMngr::AttemptWorldLoad ()
//	{
//		factory->RequestWorldLoad ();
//	}
//
//	bool FocusMngr::IsWorldReady () const
//	{
//		return (world->loadState == SceneSim::LS_LOADCOMPLETE);
//	}
//
//	void FocusMngr::ReadWorldData ()
//	{
//
//		loadColumnRadius = world->lua->ReadInt ("world/temp_columns_to_load"); // this data needs to be pushed to the room.lua
//
//#if defined (_DEBUG)
//		loadColumnRadius = 5;
//#endif
//
//	}
//
//	bool FocusMngr::GetNextColumnToLoad (SceneSim::Room * room, const Focus * focus, Int3 * outColumnId, float * outColumnDistSqr) const
//	{
//		assert (room != NULL);
//		assert (room->GetWorld () != NULL);
//		assert (focus != NULL);	
//		assert (outColumnId != NULL);
//		assert (outColumnDistSqr != NULL);
//		assert (loadColumnRadius != -1);
//
//		const int maxRadiusSqr = loadColumnRadius * loadColumnRadius;
//
//		Int3 columnIdNearest;
//		int nearestDistSqr = -1;
//
//		for (int x = -loadColumnRadius; x <= loadColumnRadius; ++x)
//		{
//			for (int z = -loadColumnRadius; z <= loadColumnRadius; ++z)
//			{
//				int distSqr = x * x + z * z;
//
//				if (distSqr <= maxRadiusSqr && (nearestDistSqr == -1 || distSqr < nearestDistSqr))
//				{
//					Int3 columnId = focus->columnId + Int3 (x, 0, z);
//					SceneSim::Column * column = SceneHelper::GetColumnFromRoom (room, columnId);
//					if (column == NULL && !factory->IsColumnRequested (room, columnId))
//					{
//						nearestDistSqr = distSqr;
//						columnIdNearest = columnId;
//					}
//				}
//			}
//		}
//
//		if (nearestDistSqr != -1)
//		{
//			*outColumnId = columnIdNearest;
//			*outColumnDistSqr = nearestDistSqr;
//			return true;
//		}
//
//		return false;
//	}
//}
