#include "stdafx.h"

#include "Mem_Record.h"
#include "Mem_Sentinels.h"

namespace Mem
{
	Record::Record ()
	{
		Reset ();
	}

	Record::~Record ()
	{
		assert (sentinel == NULL);
	}

	void Record::Reset ()
	{
		sentinel = NULL;
		adr = NULL;
	}

	void Record::Set (SentinelPre * sentinel)
	{
		assert (sentinel != NULL);
		assert (this->sentinel == NULL);

		this->sentinel = sentinel;
		this->adr = this->sentinel + 1;
	}
}
