#pragma once

namespace Profile {class Record;}
namespace Plot {void Plot_Profiler (Int2 viewportSize);}

namespace Profile
{
	class ProfileThread
	{
	public:

		ProfileThread (const char * title);
		~ProfileThread ();

		void Update ();

		int CreateRecordId (const char * name, int r, int g, int b);
		Record * GetRecord (int recordId);

		void RecordScope (int recordId);		
		void StopScope (int recordId);

		void ReportToScreen ();

	private:

		friend void Plot::Plot_Profiler (Int2 viewportSize);

		const char * title;

		const int recordsMax;
		int recordsUsedCount;
		Record * records;

		double queryPerformanceFrequency;

		int historyIdx;
	};
}
