#pragma once

namespace Profile
{
	class Record
	{
	public:

		Record ();
		~Record ();
	
		void Reset (const char * name, int r, int g, int b);

		const char * name;
		int calledCount;
		float cumulative;
		float longest;
		float mostRecent;

		unsigned char r, g, b;

		LARGE_INTEGER start;

		static const int historyLength = 1000;
		
		float history [historyLength];
	};
}
