#pragma once

#define MEMBER_OFFSET(_type, _member) \
	(void *) (& ((_type *) NULL)->_member)

namespace Utils
{
	extern int FloorDivideInt (int value, int divideBy);
	extern int LengthSqr (Int3 int3);
	extern float LengthSqr (Vec3 vec3);
	extern int CountBitsSet (unsigned int in);

	extern bool CircleSquareIntersects (const Vec3 & csgCentre, float radius, const Vec3 & colCorner, const Vec3 & colSize);

	extern bool CircleSquareIntersectsInt (const Int3 & csgCentre, int radius, const Int3 & colCorner, const Int3 & colSize);
}
